#include "BaseClass.h"
#include "Derived1.h"
#include "Derived2.h"
#include <iostream>
using namespace std;
void createObject1() {
	cout << "---A" << endl;
	BaseClass * bobj1 = new BaseClass;
	cout << "---B" << endl;
	BaseClass * bobj2 = new BaseClass(5);
	cout << "---C" << endl;
	Derived1 * dobj1 = new Derived1;
	cout << "---D" << endl;
	Derived1 * dobj2 = new Derived1(7);
	cout << "---E" << endl;
	// objects must be explicitly destroyed
	delete bobj1;
	cout << "---F" << endl;
	delete bobj2;
	cout << "---G" << endl;
	delete dobj1;
	cout << "---H" << endl;
	delete dobj2;
}
void createObject2() {
	cout << "---01" << endl;
	BaseClass bobj1;
	cout << "---02" << endl;
	BaseClass bobj2(5);
	cout << "---03" << endl;
	Derived1 dobj1;
	cout << "---04" << endl;
	Derived1 dobj2(7);
	// object are automatically destroyed
}

void createObject3() {
	// this will cause memory leak
	cout << "---I" << endl;
	BaseClass * bobj1 = new BaseClass;
	cout << "---II" << endl;
	BaseClass * bobj2 = new BaseClass(5);
	delete bobj1;
	delete bobj2;
}

void createObject4() {	
	cout << "---ALPHA" << endl;
	BaseClass * bobj1 = new Derived1(9);
	cout << "---BETA" << endl;
	BaseClass * bobj2 = new Derived2(15);
	cout << "---GAMMA" << endl;
	delete bobj1;
	cout << "---DELTA" << endl;
	delete bobj2;
}

int main(int argc, char * argv[]) {
	createObject1();
	createObject2();
	createObject3();
	createObject4();
	return 0;
}
